# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class PaymentsRetrieveRequestExpand(str, enum.Enum):
    ACCOUNT = "account"
    ACCOUNT_COMPANY = "account,company"
    APPLIED_TO_LINES = "applied_to_lines"
    APPLIED_TO_LINES_ACCOUNT = "applied_to_lines,account"
    APPLIED_TO_LINES_ACCOUNT_COMPANY = "applied_to_lines,account,company"
    APPLIED_TO_LINES_COMPANY = "applied_to_lines,company"
    APPLIED_TO_LINES_CONTACT = "applied_to_lines,contact"
    APPLIED_TO_LINES_CONTACT_ACCOUNT = "applied_to_lines,contact,account"
    APPLIED_TO_LINES_CONTACT_ACCOUNT_COMPANY = "applied_to_lines,contact,account,company"
    APPLIED_TO_LINES_CONTACT_COMPANY = "applied_to_lines,contact,company"
    COMPANY = "company"
    CONTACT = "contact"
    CONTACT_ACCOUNT = "contact,account"
    CONTACT_ACCOUNT_COMPANY = "contact,account,company"
    CONTACT_COMPANY = "contact,company"
    TRACKING_CATEGORIES = "tracking_categories"
    TRACKING_CATEGORIES_ACCOUNT = "tracking_categories,account"
    TRACKING_CATEGORIES_ACCOUNT_COMPANY = "tracking_categories,account,company"
    TRACKING_CATEGORIES_APPLIED_TO_LINES = "tracking_categories,applied_to_lines"
    TRACKING_CATEGORIES_APPLIED_TO_LINES_ACCOUNT = "tracking_categories,applied_to_lines,account"
    TRACKING_CATEGORIES_APPLIED_TO_LINES_ACCOUNT_COMPANY = "tracking_categories,applied_to_lines,account,company"
    TRACKING_CATEGORIES_APPLIED_TO_LINES_COMPANY = "tracking_categories,applied_to_lines,company"
    TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT = "tracking_categories,applied_to_lines,contact"
    TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT_ACCOUNT = "tracking_categories,applied_to_lines,contact,account"
    TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT_ACCOUNT_COMPANY = (
        "tracking_categories,applied_to_lines,contact,account,company"
    )
    TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT_COMPANY = "tracking_categories,applied_to_lines,contact,company"
    TRACKING_CATEGORIES_COMPANY = "tracking_categories,company"
    TRACKING_CATEGORIES_CONTACT = "tracking_categories,contact"
    TRACKING_CATEGORIES_CONTACT_ACCOUNT = "tracking_categories,contact,account"
    TRACKING_CATEGORIES_CONTACT_ACCOUNT_COMPANY = "tracking_categories,contact,account,company"
    TRACKING_CATEGORIES_CONTACT_COMPANY = "tracking_categories,contact,company"

    def visit(
        self,
        account: typing.Callable[[], T_Result],
        account_company: typing.Callable[[], T_Result],
        applied_to_lines: typing.Callable[[], T_Result],
        applied_to_lines_account: typing.Callable[[], T_Result],
        applied_to_lines_account_company: typing.Callable[[], T_Result],
        applied_to_lines_company: typing.Callable[[], T_Result],
        applied_to_lines_contact: typing.Callable[[], T_Result],
        applied_to_lines_contact_account: typing.Callable[[], T_Result],
        applied_to_lines_contact_account_company: typing.Callable[[], T_Result],
        applied_to_lines_contact_company: typing.Callable[[], T_Result],
        company: typing.Callable[[], T_Result],
        contact: typing.Callable[[], T_Result],
        contact_account: typing.Callable[[], T_Result],
        contact_account_company: typing.Callable[[], T_Result],
        contact_company: typing.Callable[[], T_Result],
        tracking_categories: typing.Callable[[], T_Result],
        tracking_categories_account: typing.Callable[[], T_Result],
        tracking_categories_account_company: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_account: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_account_company: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_company: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_contact: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_contact_account: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_contact_account_company: typing.Callable[[], T_Result],
        tracking_categories_applied_to_lines_contact_company: typing.Callable[[], T_Result],
        tracking_categories_company: typing.Callable[[], T_Result],
        tracking_categories_contact: typing.Callable[[], T_Result],
        tracking_categories_contact_account: typing.Callable[[], T_Result],
        tracking_categories_contact_account_company: typing.Callable[[], T_Result],
        tracking_categories_contact_company: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is PaymentsRetrieveRequestExpand.ACCOUNT:
            return account()
        if self is PaymentsRetrieveRequestExpand.ACCOUNT_COMPANY:
            return account_company()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES:
            return applied_to_lines()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_ACCOUNT:
            return applied_to_lines_account()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_ACCOUNT_COMPANY:
            return applied_to_lines_account_company()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_COMPANY:
            return applied_to_lines_company()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_CONTACT:
            return applied_to_lines_contact()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_CONTACT_ACCOUNT:
            return applied_to_lines_contact_account()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_CONTACT_ACCOUNT_COMPANY:
            return applied_to_lines_contact_account_company()
        if self is PaymentsRetrieveRequestExpand.APPLIED_TO_LINES_CONTACT_COMPANY:
            return applied_to_lines_contact_company()
        if self is PaymentsRetrieveRequestExpand.COMPANY:
            return company()
        if self is PaymentsRetrieveRequestExpand.CONTACT:
            return contact()
        if self is PaymentsRetrieveRequestExpand.CONTACT_ACCOUNT:
            return contact_account()
        if self is PaymentsRetrieveRequestExpand.CONTACT_ACCOUNT_COMPANY:
            return contact_account_company()
        if self is PaymentsRetrieveRequestExpand.CONTACT_COMPANY:
            return contact_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES:
            return tracking_categories()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_ACCOUNT:
            return tracking_categories_account()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_ACCOUNT_COMPANY:
            return tracking_categories_account_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES:
            return tracking_categories_applied_to_lines()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_ACCOUNT:
            return tracking_categories_applied_to_lines_account()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_ACCOUNT_COMPANY:
            return tracking_categories_applied_to_lines_account_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_COMPANY:
            return tracking_categories_applied_to_lines_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT:
            return tracking_categories_applied_to_lines_contact()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT_ACCOUNT:
            return tracking_categories_applied_to_lines_contact_account()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT_ACCOUNT_COMPANY:
            return tracking_categories_applied_to_lines_contact_account_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_APPLIED_TO_LINES_CONTACT_COMPANY:
            return tracking_categories_applied_to_lines_contact_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_COMPANY:
            return tracking_categories_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_CONTACT:
            return tracking_categories_contact()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_CONTACT_ACCOUNT:
            return tracking_categories_contact_account()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_CONTACT_ACCOUNT_COMPANY:
            return tracking_categories_contact_account_company()
        if self is PaymentsRetrieveRequestExpand.TRACKING_CATEGORIES_CONTACT_COMPANY:
            return tracking_categories_contact_company()
