# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class PurchaseOrdersListRequestExpand(str, enum.Enum):
    COMPANY = "company"
    DELIVERY_ADDRESS = "delivery_address"
    DELIVERY_ADDRESS_COMPANY = "delivery_address,company"
    DELIVERY_ADDRESS_VENDOR = "delivery_address,vendor"
    DELIVERY_ADDRESS_VENDOR_COMPANY = "delivery_address,vendor,company"
    LINE_ITEMS = "line_items"
    LINE_ITEMS_COMPANY = "line_items,company"
    LINE_ITEMS_DELIVERY_ADDRESS = "line_items,delivery_address"
    LINE_ITEMS_DELIVERY_ADDRESS_COMPANY = "line_items,delivery_address,company"
    LINE_ITEMS_DELIVERY_ADDRESS_VENDOR = "line_items,delivery_address,vendor"
    LINE_ITEMS_DELIVERY_ADDRESS_VENDOR_COMPANY = "line_items,delivery_address,vendor,company"
    LINE_ITEMS_TRACKING_CATEGORIES = "line_items,tracking_categories"
    LINE_ITEMS_TRACKING_CATEGORIES_COMPANY = "line_items,tracking_categories,company"
    LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS = "line_items,tracking_categories,delivery_address"
    LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS_COMPANY = "line_items,tracking_categories,delivery_address,company"
    LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR = "line_items,tracking_categories,delivery_address,vendor"
    LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR_COMPANY = (
        "line_items,tracking_categories,delivery_address,vendor,company"
    )
    LINE_ITEMS_TRACKING_CATEGORIES_VENDOR = "line_items,tracking_categories,vendor"
    LINE_ITEMS_TRACKING_CATEGORIES_VENDOR_COMPANY = "line_items,tracking_categories,vendor,company"
    LINE_ITEMS_VENDOR = "line_items,vendor"
    LINE_ITEMS_VENDOR_COMPANY = "line_items,vendor,company"
    TRACKING_CATEGORIES = "tracking_categories"
    TRACKING_CATEGORIES_COMPANY = "tracking_categories,company"
    TRACKING_CATEGORIES_DELIVERY_ADDRESS = "tracking_categories,delivery_address"
    TRACKING_CATEGORIES_DELIVERY_ADDRESS_COMPANY = "tracking_categories,delivery_address,company"
    TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR = "tracking_categories,delivery_address,vendor"
    TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR_COMPANY = "tracking_categories,delivery_address,vendor,company"
    TRACKING_CATEGORIES_VENDOR = "tracking_categories,vendor"
    TRACKING_CATEGORIES_VENDOR_COMPANY = "tracking_categories,vendor,company"
    VENDOR = "vendor"
    VENDOR_COMPANY = "vendor,company"

    def visit(
        self,
        company: typing.Callable[[], T_Result],
        delivery_address: typing.Callable[[], T_Result],
        delivery_address_company: typing.Callable[[], T_Result],
        delivery_address_vendor: typing.Callable[[], T_Result],
        delivery_address_vendor_company: typing.Callable[[], T_Result],
        line_items: typing.Callable[[], T_Result],
        line_items_company: typing.Callable[[], T_Result],
        line_items_delivery_address: typing.Callable[[], T_Result],
        line_items_delivery_address_company: typing.Callable[[], T_Result],
        line_items_delivery_address_vendor: typing.Callable[[], T_Result],
        line_items_delivery_address_vendor_company: typing.Callable[[], T_Result],
        line_items_tracking_categories: typing.Callable[[], T_Result],
        line_items_tracking_categories_company: typing.Callable[[], T_Result],
        line_items_tracking_categories_delivery_address: typing.Callable[[], T_Result],
        line_items_tracking_categories_delivery_address_company: typing.Callable[[], T_Result],
        line_items_tracking_categories_delivery_address_vendor: typing.Callable[[], T_Result],
        line_items_tracking_categories_delivery_address_vendor_company: typing.Callable[[], T_Result],
        line_items_tracking_categories_vendor: typing.Callable[[], T_Result],
        line_items_tracking_categories_vendor_company: typing.Callable[[], T_Result],
        line_items_vendor: typing.Callable[[], T_Result],
        line_items_vendor_company: typing.Callable[[], T_Result],
        tracking_categories: typing.Callable[[], T_Result],
        tracking_categories_company: typing.Callable[[], T_Result],
        tracking_categories_delivery_address: typing.Callable[[], T_Result],
        tracking_categories_delivery_address_company: typing.Callable[[], T_Result],
        tracking_categories_delivery_address_vendor: typing.Callable[[], T_Result],
        tracking_categories_delivery_address_vendor_company: typing.Callable[[], T_Result],
        tracking_categories_vendor: typing.Callable[[], T_Result],
        tracking_categories_vendor_company: typing.Callable[[], T_Result],
        vendor: typing.Callable[[], T_Result],
        vendor_company: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is PurchaseOrdersListRequestExpand.COMPANY:
            return company()
        if self is PurchaseOrdersListRequestExpand.DELIVERY_ADDRESS:
            return delivery_address()
        if self is PurchaseOrdersListRequestExpand.DELIVERY_ADDRESS_COMPANY:
            return delivery_address_company()
        if self is PurchaseOrdersListRequestExpand.DELIVERY_ADDRESS_VENDOR:
            return delivery_address_vendor()
        if self is PurchaseOrdersListRequestExpand.DELIVERY_ADDRESS_VENDOR_COMPANY:
            return delivery_address_vendor_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS:
            return line_items()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_COMPANY:
            return line_items_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_DELIVERY_ADDRESS:
            return line_items_delivery_address()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_DELIVERY_ADDRESS_COMPANY:
            return line_items_delivery_address_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_DELIVERY_ADDRESS_VENDOR:
            return line_items_delivery_address_vendor()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_DELIVERY_ADDRESS_VENDOR_COMPANY:
            return line_items_delivery_address_vendor_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES:
            return line_items_tracking_categories()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_COMPANY:
            return line_items_tracking_categories_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS:
            return line_items_tracking_categories_delivery_address()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS_COMPANY:
            return line_items_tracking_categories_delivery_address_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR:
            return line_items_tracking_categories_delivery_address_vendor()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR_COMPANY:
            return line_items_tracking_categories_delivery_address_vendor_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_VENDOR:
            return line_items_tracking_categories_vendor()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_TRACKING_CATEGORIES_VENDOR_COMPANY:
            return line_items_tracking_categories_vendor_company()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_VENDOR:
            return line_items_vendor()
        if self is PurchaseOrdersListRequestExpand.LINE_ITEMS_VENDOR_COMPANY:
            return line_items_vendor_company()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES:
            return tracking_categories()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_COMPANY:
            return tracking_categories_company()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_DELIVERY_ADDRESS:
            return tracking_categories_delivery_address()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_DELIVERY_ADDRESS_COMPANY:
            return tracking_categories_delivery_address_company()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR:
            return tracking_categories_delivery_address_vendor()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_DELIVERY_ADDRESS_VENDOR_COMPANY:
            return tracking_categories_delivery_address_vendor_company()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_VENDOR:
            return tracking_categories_vendor()
        if self is PurchaseOrdersListRequestExpand.TRACKING_CATEGORIES_VENDOR_COMPANY:
            return tracking_categories_vendor_company()
        if self is PurchaseOrdersListRequestExpand.VENDOR:
            return vendor()
        if self is PurchaseOrdersListRequestExpand.VENDOR_COMPANY:
            return vendor_company()
